3 # Copyright (c) 2005 Junio C Hamano
6 USAGE='[-n] [--summary] [--no-commit] [--squash] [-s <strategy>] [-m=<merge-message>] <commit>+'
13 test -z "$(git ls-files -u)" ||
14 die "You are in the middle of a conflicted merge."
19 all_strategies='recur recursive octopus resolve stupid ours subtree'
20 default_twohead_strategies='recursive'
21 default_octopus_strategies='octopus'
22 no_fast_forward_strategies='subtree ours'
23 no_trivial_strategies='recursive recur subtree ours'
30 rm -f -- "$GIT_DIR/MERGE_HEAD" "$GIT_DIR/MERGE_MSG" \
31 "$GIT_DIR/MERGE_SAVE" || exit 1
35 # Stash away any local modifications.
36 git diff-index -z --name-only $head |
37 cpio -0 -o >"$GIT_DIR/MERGE_SAVE"
41 if test -f "$GIT_DIR/MERGE_SAVE"
43 git reset --hard $head >/dev/null
44 cpio -iuv <"$GIT_DIR/MERGE_SAVE"
45 git update-index --refresh >/dev/null
49 finish_up_to_date () {
52 echo "$1 (nothing to squash)" ;;
60 echo Squashed commit of the following:
62 git log --no-merges ^"$head" $remote
68 rlogm="$GIT_REFLOG_ACTION"
71 rlogm="$GIT_REFLOG_ACTION: $2"
75 echo "Squash commit -- not updating HEAD"
76 squash_message >"$GIT_DIR/SQUASH_MSG"
81 echo "No merge message -- not updating HEAD"
84 git update-ref -m "$rlogm" HEAD "$1" "$head" || exit 1
93 if test "$show_diffstat" = t
95 # We want color (if set), but no pager
96 GIT_PAGER='' git diff --stat --summary -M "$head" "$1"
104 rh=$(git rev-parse --verify "$remote^0" 2>/dev/null) || return
105 bh=$(git show-ref -s --verify "refs/heads/$remote" 2>/dev/null)
106 if test "$rh" = "$bh"
108 echo "$rh branch '$remote' of ."
109 elif truname=$(expr "$remote" : '\(.*\)~[1-9][0-9]*$') &&
110 git show-ref -q --verify "refs/heads/$truname" 2>/dev/null
112 echo "$rh branch '$truname' (early part) of ."
113 elif test "$remote" = "FETCH_HEAD" -a -r "$GIT_DIR/FETCH_HEAD"
115 sed -e 's/ not-for-merge / /' -e 1q \
116 "$GIT_DIR/FETCH_HEAD"
118 echo "$rh commit '$remote'"
122 case "$#" in 0) usage ;; esac
125 while case "$#" in 0) break ;; esac
128 -n|--n|--no|--no-|--no-s|--no-su|--no-sum|--no-summ|\
129 --no-summa|--no-summar|--no-summary)
130 show_diffstat=false ;;
133 --sq|--squ|--squa|--squas|--squash)
134 squash=t no_commit=t ;;
135 --no-c|--no-co|--no-com|--no-comm|--no-commi|--no-commit)
137 -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
138 --strateg=*|--strategy=*|\
139 -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
142 strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
149 case " $all_strategies " in
151 use_strategies="$use_strategies$strategy " ;;
153 die "available strategies are: $all_strategies" ;;
156 -m=*|--m=*|--me=*|--mes=*|--mess=*|--messa=*|--messag=*|--message=*)
157 merge_msg=`expr "z$1" : 'z-[^=]*=\(.*\)'`
160 -m|--m|--me|--mes|--mess|--messa|--messag|--message)
174 if test -z "$show_diffstat"; then
175 test "$(git config --bool merge.diffstat)" = false && show_diffstat=false
176 test -z "$show_diffstat" && show_diffstat=t
179 # This could be traditional "merge <msg> HEAD <commit>..." and the
180 # way we can tell it is to see if the second token is HEAD, but some
181 # people might have misused the interface and used a committish that
182 # is the same as HEAD there instead. Traditional format never would
183 # have "-m" so it is an additional safety measure to check for it.
185 if test -z "$have_message" &&
186 second_token=$(git rev-parse --verify "$2^0" 2>/dev/null) &&
187 head_commit=$(git rev-parse --verify "HEAD" 2>/dev/null) &&
188 test "$second_token" = "$head_commit"
194 elif ! git rev-parse --verify HEAD >/dev/null 2>&1
196 # If the merged head is a valid one there is no reason to
197 # forbid "git merge" into a branch yet to be born. We do
198 # the same for "git pull".
201 echo >&2 "Can merge only exactly one commit into empty head"
205 rh=$(git rev-parse --verify "$1^0") ||
206 die "$1 - not something we can merge"
208 git update-ref -m "initial pull" HEAD "$rh" "" &&
209 git read-tree --reset -u HEAD
213 # We are invoked directly as the first-class UI.
216 # All the rest are the commits being merged; prepare
217 # the standard merge summary message to be appended to
218 # the given message. If remote is invalid we will die
219 # later in the common codepath so we discard the error
221 merge_name=$(for remote
224 done | git fmt-merge-msg
226 merge_msg="${merge_msg:+$merge_msg$LF$LF}$merge_name"
228 head=$(git rev-parse --verify "$head_arg"^0) || usage
230 # All the rest are remote heads
231 test "$#" = 0 && usage ;# we need at least one remote head.
232 set_reflog_action "merge $*"
237 remotehead=$(git rev-parse --verify "$remote"^0 2>/dev/null) ||
238 die "$remote - not something we can merge"
239 remoteheads="${remoteheads}$remotehead "
240 eval GITHEAD_$remotehead='"$remote"'
241 export GITHEAD_$remotehead
243 set x $remoteheads ; shift
245 case "$use_strategies" in
249 var="`git config --get pull.twohead`"
252 use_strategies="$var"
254 use_strategies="$default_twohead_strategies"
257 var="`git config --get pull.octopus`"
260 use_strategies="$var"
262 use_strategies="$default_octopus_strategies"
268 for s in $use_strategies
270 for ss in $no_fast_forward_strategies
279 for ss in $no_trivial_strategies
283 allow_trivial_merge=f
292 common=$(git merge-base --all $head "$@")
295 common=$(git show-branch --merge-base $head "$@")
298 echo "$head" >"$GIT_DIR/ORIG_HEAD"
300 case "$allow_fast_forward,$#,$common,$no_commit" in
302 # No common ancestors found. We need a real merge.
305 # If head can reach all the merge then we are up to date.
306 # but first the most common case of merging one remote.
307 finish_up_to_date "Already up-to-date."
311 # Again the most common case of merging one remote.
312 echo "Updating $(git rev-parse --short $head)..$(git rev-parse --short $1)"
313 git update-index --refresh 2>/dev/null
315 if test -n "$have_message"
317 msg="$msg (no commit created; -m option ignored)"
319 new_head=$(git rev-parse --verify "$1^0") &&
320 git read-tree -v -m -u --exclude-per-directory=.gitignore $head "$new_head" &&
321 finish "$new_head" "$msg" || exit
326 # We are not doing octopus and not fast forward. Need a
330 # We are not doing octopus, not fast forward, and have only
332 git update-index --refresh 2>/dev/null
333 case "$allow_trivial_merge" in
335 # See if it is really trivial.
336 git var GIT_COMMITTER_IDENT >/dev/null || exit
337 echo "Trying really trivial in-index merge..."
338 if git read-tree --trivial -m -u -v $common $head "$1" &&
339 result_tree=$(git write-tree)
343 printf '%s\n' "$merge_msg" |
344 git commit-tree $result_tree -p HEAD -p "$1"
346 finish "$result_commit" "In-index merge"
354 # An octopus. If we can reach all the remote we are up to date.
358 common_one=$(git merge-base --all $head $remote)
359 if test "$common_one" != "$remote"
365 if test "$up_to_date" = t
367 finish_up_to_date "Already up-to-date. Yeeah!"
373 # We are going to make a new commit.
374 git var GIT_COMMITTER_IDENT >/dev/null || exit
376 # At this point, we need a real merge. No matter what strategy
377 # we use, it would operate on the index, possibly affecting the
378 # working tree, and when resolved cleanly, have the desired tree
379 # in the index -- this means that the index must be in sync with
380 # the $head commit. The strategies are responsible to ensure this.
382 case "$use_strategies" in
384 # Stash away the local changes so that we can try more than one.
389 rm -f "$GIT_DIR/MERGE_SAVE"
394 result_tree= best_cnt=-1 best_strategy= wt_strategy=
396 for strategy in $use_strategies
398 test "$wt_strategy" = '' || {
399 echo "Rewinding the tree to pristine..."
402 case "$single_strategy" in
404 echo "Trying merge strategy $strategy..."
408 # Remember which strategy left the state in the working tree
409 wt_strategy=$strategy
411 git-merge-$strategy $common -- "$head_arg" "$@"
413 if test "$no_commit" = t && test "$exit" = 0
416 exit=1 ;# pretend it left conflicts.
419 test "$exit" = 0 || {
421 # The backend exits with 1 when conflicts are left to be resolved,
422 # with 2 when it does not handle the given merge at all.
424 if test "$exit" -eq 1
427 git diff-files --name-only
428 git ls-files --unmerged
430 if test $best_cnt -le 0 -o $cnt -le $best_cnt
432 best_strategy=$strategy
439 # Automerge succeeded.
440 result_tree=$(git write-tree) && break
443 # If we have a resulting tree, that means the strategy module
444 # auto resolved the merge cleanly.
445 if test '' != "$result_tree"
447 parents=$(git show-branch --independent "$head" "$@" | sed -e 's/^/-p /')
448 result_commit=$(printf '%s\n' "$merge_msg" | git commit-tree $result_tree $parents) || exit
449 finish "$result_commit" "Merge made by $wt_strategy."
454 # Pick the result from the best strategy and have the user fix it up.
455 case "$best_strategy" in
458 case "$use_strategies" in
460 echo >&2 "No merge strategy handled the merge."
463 echo >&2 "Merge with strategy $use_strategies failed."
469 # We already have its result in the working tree.
472 echo "Rewinding the tree to pristine..."
474 echo "Using the $best_strategy to prepare resolving by hand."
475 git-merge-$best_strategy $common -- "$head_arg" "$@"
479 if test "$squash" = t
486 done >"$GIT_DIR/MERGE_HEAD"
487 printf '%s\n' "$merge_msg" >"$GIT_DIR/MERGE_MSG"
490 if test "$merge_was_ok" = t
493 "Automatic merge went well; stopped before committing as requested"
500 git ls-files --unmerged |
501 sed -e 's/^[^ ]* / /' |
503 } >>"$GIT_DIR/MERGE_MSG"
505 die "Automatic merge failed; fix conflicts and then commit the result."